%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

#no jars in this native build, so skip signing
%define _jarsign_opts --nocopy

# jbhomedir is /usr/share/jbossas  (files must be immutable)
%define jbhomedir %{_datadir}/jbossas
%define jbosswebnativedir modules/system/layers/base/org/jboss/as/web/main/lib

%define _with_zips 1
# If you want to build the zips,
# give rpmbuild option '--with zips'

%define with_zips %{?_with_zips:1}%{!?_with_zips:0}
%define without_zips %{!?_with_zips:1}%{?_with_zips:0}

Name:           tomcat-native
Version:        1.1.32
Release:        2.redhat_2%{?dist}
Summary:        Tomcat native library

Group:          System Environment/Libraries
License:        ASL 2.0
URL:            http://tomcat.apache.org/tomcat-6.0-doc/apr.html
Source0:        http://archive.apache.org/dist/tomcat/tomcat-connectors/native/1.1.32/source/tomcat-native-1.1.32-src.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if "%{?rhel}" == "7"
#64 bit only natives on RHEL 7
ExcludeArch:   i686 i386
%endif

%if "%{?rhel}" == "7"
BuildRequires:  java-devel
BuildRequires:  apr, apr-devel >= 1.2.1
%else
BuildRequires:  java7-devel
BuildRequires:  apr-jws3, apr-jws3-devel >= 1.4.8
%endif
BuildRequires:  jpackage-utils
BuildRequires:  openssl, openssl-devel
BuildRequires:  zip
%if "%{?rhel}" == "7"
BuildRequires:  openssl-libs
%endif
# Upstream compatibility:
Provides:       tcnative = %{version}-%{release}

%description
Tomcat can use the Apache Portable Runtime to provide superior
scalability, performance, and better integration with native server
technologies.  The Apache Portable Runtime is a highly portable library
that is at the heart of Apache HTTP Server 2.x.  APR has many uses,
including access to advanced IO functionality (such as sendfile, epoll
and OpenSSL), OS level functionality (random number generation, system
status, etc), and native process handling (shared memory, NT pipes and
Unix sockets).  This package contains the Tomcat native library which
provides support for using APR in Tomcat.

%package -n jbossas-jbossweb-native
Summary:     JBossWeb native library for JBoss EAP 6.
Group:       Development
%if "%{?rhel}" == "7"
Requires:    apr, openssl
%else
Requires:    apr-jws3, openssl
%endif

%description -n jbossas-jbossweb-native
JBossWeb native library for JBoss EAP 6.

%if %{with_zips}
%package src-zip
Summary:     Container for the sources of the Tomcat native library.
Group:       Development

%description src-zip
Container for the sources of the Tomcat native library
%endif

%prep
%setup -q -n %{name}-%{version}-src

%if %{with_zips}
zip -q -r ../%{name}-%{version}-src.zip *
%endif

%build
cd jni/native
%configure \
%if "%{?rhel}" == "7"
    --with-apr=%{_bindir}/apr-1-config \
%else
    --with-apr=%{_bindir}/apr-jws3-1-config \
%endif
    --with-java-home=%{java_home} \
    --with-java-platform=2
make %{?_smp_mflags} CFLAGS=-fno-strict-aliasing


%install
rm -rf $RPM_BUILD_ROOT
make -C jni/native install DESTDIR=$RPM_BUILD_ROOT
# Perhaps a devel package sometime?  Not for now; no headers are installed.
rm -f $RPM_BUILD_ROOT%{_libdir}/libtcnative*.*a
rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig

%ifarch i386 i686
archdir=linux-i686
%endif
%ifarch ppc64
archdir=linux-ppc64
%endif
%ifarch x86_64
archdir=linux-x86_64
%endif
mkdir -p $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir
cp -L $RPM_BUILD_ROOT%{_libdir}/libtcnative-1.so $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir/
%if "%{?rhel}" == "7"
(cd $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir && for i in `ls %{_libdir}/libapr-1.so.0`; do ln -s $i libapr-1.so; done)
%else
(cd $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir && for i in `ls %{_libdir}/libapr-jws3-1.so.0`; do ln -s $i libapr-jws3-1.so; done)
%endif
%if "%{?rhel}" == "5"
(cd $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir && for i in `ls /%{_lib}/libssl.so.6`; do ln -s $i libssl.so; done)
(cd $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir && for i in `ls /%{_lib}/libcrypto.so.6`; do ln -s $i libcrypto.so; done)
%else
# these symlinks are the same for RHEL 6 and 7
(cd $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir && for i in `ls %{_libdir}/libssl.so.10`; do ln -s $i libssl.so; done)
(cd $RPM_BUILD_ROOT/%{jbhomedir}/%{jbosswebnativedir}/$archdir && for i in `ls %{_libdir}/libcrypto.so.10`; do ln -s $i libcrypto.so; done)
%endif

%if %{with_zips}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} ../%{name}-%{version}-src.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/
%endif

%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%pre -n jbossas-jbossweb-native
JBOSS_SHELL=/sbin/nologin
%{_sbindir}/groupadd -r jboss 2>/dev/null || :
%{_sbindir}/useradd -c JBossAS -r -s $JBOSS_SHELL -d %{_localstatedir}/lib/jbossas -g jboss jboss 2>/dev/null || :

%files
%defattr(-,root,root,-)
%doc CHANGELOG.txt LICENSE NOTICE
# Note: unversioned *.so needed here due to how Tomcat loads the lib :(
%{_libdir}/libtcnative*.so*

%files -n jbossas-jbossweb-native
%defattr(0644,jboss,jboss,0755)
%dir %{_datadir}/jbossas
%dir %{_datadir}/jbossas/modules
%dir %{_datadir}/jbossas/modules/system
%dir %{_datadir}/jbossas/modules/system/layers
%dir %{_datadir}/jbossas/modules/system/layers/base
%dir %{_datadir}/jbossas/modules/system/layers/base/org
%dir %{_datadir}/jbossas/modules/system/layers/base/org/jboss/as
%dir %{_datadir}/jbossas/modules/system/layers/base/org/jboss/as/web
%dir %{_datadir}/jbossas/modules/system/layers/base/org/jboss/as/web/main
%dir %{jbhomedir}/%{jbosswebnativedir}
%dir %{jbhomedir}/%{jbosswebnativedir}/*/
%{jbhomedir}/%{jbosswebnativedir}/*

%if %{with_zips}
%files src-zip
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev/%{name}-%{version}-src.zip
%endif

%changelog
* Thu Dec 11 2014 Permaine Cheung <pcheung@redhat.com>  - 1.1.32-2.redhat_2
- Build against apr-jws3 on RHEL 6

* Mon Oct 27 2014 Permaine Cheung <pcheung@redhat.com>  - 1.1.32-1.redhat_1
- 1.1.32
- Remove patch that's already incorporated in new tag

* Fri Sep 26 2014 Permaine Cheung <pcheung@redhat.com>  - 1.1.30-3.redhat_1
- JWS 3.0 build
